;Beitrag von Diedel fr den BCC24 :D
;-------------------------------------------------------------------------------------------
;Ich hoffe Ihr kapiert den Code, ich habe versucht ihn mit Hilfe von Kommentaren etwas zu
;erklren um euch einen Ansatz zu geben
;
;Der Code ist Free und ich werde Euch das Ganze auchnoch in eine handliche Funktion
;verpacken ; --- )
;-------------------------------------------------------------------------------------------



;Pfad aus Commandline herauslesen
cmd$=CommandLine()
cmd=Replace(cmd," "+Chr(34),"")
cmd=Replace(cmd,Chr(34)+" ","")
cmd=Replace(cmd,Chr(34),"")
If cmd="" Then
	RuntimeError "Whlen Sie geflligst ein Bild aus!"
EndIf



;Bildladen
image=LoadImage(cmd)
If Not image RuntimeError "Das Bild konnte nicht geladen werden ?!"

;Millisekunden speichern, um spter anzeigen zu knnen wie lange die Berechnung brauchte
ms=MilliSecs()

;Variablen vorbereiten
Global xmax=ImageWidth(image)-1
Global ymax=ImageHeight(image)-1
Global Size=Int(xmax/80.0)+1
Global Careless=Size
Dim img(xmax*2/Size,ymax*2/Size)
imgbuf=ImageBuffer(image)

;Ein Bild anhand der vorhandenen Farb/Hellichkeitstolleranzen erstellen und in das Array
;img(x,y) mit halber Auflsung fr schnellen Zugriff abspeichern
LockBuffer imgbuf
For x=0 To xmax-1
	For y=0 To ymax-1
		If img(x/Size,y/Size)=0 Then
			rgb=ReadPixelFast(x,y,imgbuf)
			If (rgb And $FF0000)/$10000<50 Or (rgb And $FF00)/$100<50 Or (rgb And $FF)<50 Then
				img(x/Size,y/Size)=1
			Else
				img(x/Size,y/Size)=2
			EndIf
		EndIf
	Next
Next
UnlockBuffer imgbuf

;Alle in Frage kommenden Winkel berpfrfen, der Winkel mit der grten bereinstimmung
;wird gespeichert
x=xmax*0.4/size
While x<=xmax*0.6/size
	y=ymax*0.4/size
	While y<=ymax*0.6/size
		w#=0
		While w<=170+Careless*5
			l=Look(w,x,y)
			If l>=lg Then
				lg=l
				wg=w
				xg=x
				yg=y
			EndIf
			w=w+Careless*5
		Wend
		y=y+Careless
	Wend
	x=x+Careless
Wend
xg=xg*size
yg=yg*size

;Ende der Berechnungen, es werden wieder die Millisekunden gespeichert
ems=MilliSecs()


;Das Bild mit der Symetrieachse anzeigen
DrawImage image,0,0
DrawSym xg,yg,wg,xmax,ymax

;Den Text anzeigen, die Berechnungszeit betrgt die zuletzt gemmesenen Millisekunden (ems)
;- die am Anfrag gemessenen (ms)
Color 255,255,255
Text 0,ymax+10,"Berechnungszeit: "+(ems-ms)+"ms / "+(1000.0/(ems-ms))+" FPS"
Color 255,255,0
Text 0,ymax+24,"Pos: "+xg+"|"+yg+"  Winkel: "+wg+""
Color 0,255,0
Text 0,ymax+38,"bereinstimmung: "+lg
Text 0,ymax+60,Size+"|"+Careless

;Auf Tastenbettigung warten und dannach beenden
WaitKey
End


;Diese Funktion schau im Array img(x,y) nach bereinstimmungen an Winkel w und der Position
;x,y
Function Look(w#,sx,sy)
	Local x1#,y1#
	Local x2#,y2#
	Local x3#,y3#
	Local zahl
	For x=0 To xmax/2/size
		For y=-ymax/2/size To ymax/2/size
			x1=sx+Cos(w)*y:y1=sy+Sin(w)*y
			x2=x1+Cos(w-90)*x:y2=y1+Sin(w-90)*x
			x3=x1+Cos(w+90)*x:y3=y1+Sin(w+90)*x
			g1=Get(x2,y2):g2=Get(x3,y3)
			zahl=zahl+((g1=0 Or g2=0)Or(g1=g2 And g1>0 And g2>0))
		Next
	Next
	Return zahl
End Function

;Diese Funktion gibt den Wert eines Punktes des Arrays img(x,y) aus
Function Get(x,y)
	If x<0 Or y<0 Then Return 0
	Return img(x,y)
End Function

;Diese Funktion zeichnet die gestrichelte Symetrieachse ein
Function DrawSym(xg,yg,wg,xmax,ymax)
	Viewport 0,0,xmax,ymax
	Color 255,0,0
	Color 0,0,255
	For z=-xmax To xmax Step 10
		Line xg+Cos(wg)*z,yg+Sin(wg)*z,xg+Cos(wg)*(z-5),yg+Sin(wg)*(z-5)
	Next
	Color 255,0,0
	For z=-xmax To xmax Step 10
		Line xg+Cos(wg)*z,yg+Sin(wg)*z,xg+Cos(wg)*(z+5),yg+Sin(wg)*(z+5)
	Next
	Viewport 0,0,GraphicsWidth(),GraphicsHeight()
End Function




